package hok.model;

import java.util.Set;
import java.util.TreeSet;

/**
 * The ATreeModel is the model for the TreeViewer of the ConstraintDialog. It
 * implements the Composite design pattern.
 * 
 * @author holger
 * 
 */
public abstract class ATreeModel implements ITreeListeners, ITreeNode {

	private Set<ITreeNode> children;

	/**
	 * @uml.property  name="parent"
	 * @uml.associationEnd  multiplicity="(1 1)" inverse="aTreeModel1:hok.model.ITreeNode"
	 */
	private ITreeNode parent;

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeListeners#addListener(hok.model.ITreeNode)
	 */
	public void addListener(ITreeNode element) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeListeners#removeListener(hok.model.ITreeNode)
	 */
	public void removeListener(ITreeNode element) {
		// TODO Auto-generated method stub

	}

	/**
	 * The Constructor. It sets the parent of this element or null if this
	 * element is the root of the tree.
	 * 
	 * @param parent
	 *            the parent element or null.
	 */
	public ATreeModel(ITreeNode parent) {
		this.children = new TreeSet<ITreeNode>();
		this.parent = parent;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeNode#getChildren(hok.model.ITreeNode)
	 */
	public Set<ITreeNode> getChildren(ITreeNode parentElement) {
		return this.children;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeNode#getParent()
	 */
	public ITreeNode getParent() {

		return this.parent;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeNode#hasChildren()
	 */
	public boolean hasChildren() {
		//
		return this.children.size() > 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeNode#addChild(hok.model.ITreeNode)
	 */
	public void addChild(ITreeNode child) {
		
		this.children.add(child);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see hok.model.ITreeNode#removeChild(hok.model.ITreeNode)
	 */
	public void removeChild(ITreeNode child) {
		// do nothing, not supported

	}

}
