package hok.model;

/**
 * Interface that provides methods to add and remove listeners that are
 * interested in changes of the model.
 * 
 * @author holger
 * 
 */
public interface ITreeListeners {

	/**
	 * Removes a listener from the model.
	 * 
	 * @param element
	 *            the listener to remove.
	 */
	public void removeListener(ITreeNode element);

	/**
	 * Adds a listener to the model.
	 * 
	 * @param element
	 *            the listener to add.
	 */
	public void addListener(ITreeNode element);

}
