package hok.model;

import hok.ui.wizard.ResultDialog;

import java.util.Vector;

import org.eclipse.jface.viewers.TableViewer;

/**
 * The {@link PatternModel} is the model of the {@link TableViewer} of the
 * {@link ResultDialog}. It holds a collection of {@link PatternElement}.
 * 
 * @author holger
 * 
 */
public class PatternModel {

	private final int COUNT = 10;

	private Vector<PatternElement> patterns = new Vector<PatternElement>(COUNT);

	/**
	 * Adds a {@link PatternElement} to the collection.
	 * 
	 * @param element
	 *            the {@link PatternElement} to add.
	 */
	public void addPattern(PatternElement element) {
		if (!this.patterns.contains(element)) {
			this.patterns.add(element);
		}
	}

	/**
	 * Returns the collection of {@link PatternElement}.
	 * 
	 * @return the collection of {@link PatternElement}.
	 */
	public Vector<PatternElement> getPatterns() {
		return this.patterns;
	}

}
