package hok.ui.wizard;

import hok.model.ConstraintRow;

/**
 * Provides methods for managing ConstraintRow constraints.
 * 
 * @author holger
 * 
 */
public interface IConstraintViewer {

	/**
	 * Add a sparql constraint row to the list.
	 * 
	 * @param constraint
	 *            the sparql constraint row to add.
	 */
	public void addConstraint(ConstraintRow constraint);

	/**
	 * Update the view to reflect the fact that a constraint was removed from
	 * the constraint list
	 * 
	 * @param constraint
	 *            the sparql constraint row to remove.
	 */
	public void removeConstraint(ConstraintRow constraint);

	/**
	 * Update the view to reflect the fact that one of the constraint was
	 * modified
	 * 
	 * @param constraint
	 *            the sparql constraint row to update.
	 */
	public void updateConstraint(ConstraintRow constraint);

}
